package org.jeecg.modules.financeManage.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.financeManage.entity.FdProjectReceivables;
import org.jeecg.modules.financeManage.entity.FdProjectReceivablesUpload;
import org.jeecg.modules.financeManage.service.IFdProjectReceivablesUploadService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 项目因收款附件表
 * @author： jeecg-boot
 * @date：   2019-09-09
 * @version： V1.0
 */
@RestController
@RequestMapping("/financeManage/fdProjectReceivablesUpload")
@Slf4j
public class FdProjectReceivablesUploadController {
	@Autowired
	private IFdProjectReceivablesUploadService fdProjectReceivablesUploadService;
	
	/**
	  * 分页列表查询
	 * @param fdProjectReceivablesUpload
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FdProjectReceivablesUpload>> queryPageList(FdProjectReceivablesUpload fdProjectReceivablesUpload,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FdProjectReceivablesUpload>> result = new Result<IPage<FdProjectReceivablesUpload>>();
		QueryWrapper<FdProjectReceivablesUpload> queryWrapper = QueryGenerator.initQueryWrapper(fdProjectReceivablesUpload, req.getParameterMap());
		queryWrapper.lambda().orderByAsc(FdProjectReceivablesUpload::getSort);
		Page<FdProjectReceivablesUpload> page = new Page<FdProjectReceivablesUpload>(pageNo, pageSize);
		IPage<FdProjectReceivablesUpload> pageList = fdProjectReceivablesUploadService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fdProjectReceivablesUpload
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FdProjectReceivablesUpload> add(@RequestBody FdProjectReceivablesUpload fdProjectReceivablesUpload) {
		Result<FdProjectReceivablesUpload> result = new Result<FdProjectReceivablesUpload>();
		try {
			fdProjectReceivablesUploadService.save(fdProjectReceivablesUpload);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fdProjectReceivablesUpload
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FdProjectReceivablesUpload> edit(@RequestBody FdProjectReceivablesUpload fdProjectReceivablesUpload) {
		Result<FdProjectReceivablesUpload> result = new Result<FdProjectReceivablesUpload>();
		FdProjectReceivablesUpload fdProjectReceivablesUploadEntity = fdProjectReceivablesUploadService.getById(fdProjectReceivablesUpload.getId());
		if(fdProjectReceivablesUploadEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdProjectReceivablesUploadService.updateById(fdProjectReceivablesUpload);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FdProjectReceivablesUpload> delete(@RequestParam(name="id",required=true) String id) {
		Result<FdProjectReceivablesUpload> result = new Result<FdProjectReceivablesUpload>();
		FdProjectReceivablesUpload fdProjectReceivablesUpload = fdProjectReceivablesUploadService.getById(id);
		if(fdProjectReceivablesUpload==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdProjectReceivablesUploadService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FdProjectReceivablesUpload> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FdProjectReceivablesUpload> result = new Result<FdProjectReceivablesUpload>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fdProjectReceivablesUploadService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FdProjectReceivablesUpload> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FdProjectReceivablesUpload> result = new Result<FdProjectReceivablesUpload>();
		FdProjectReceivablesUpload fdProjectReceivablesUpload = fdProjectReceivablesUploadService.getById(id);
		if(fdProjectReceivablesUpload==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fdProjectReceivablesUpload);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FdProjectReceivablesUpload> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FdProjectReceivablesUpload fdProjectReceivablesUpload = JSON.parseObject(deString, FdProjectReceivablesUpload.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fdProjectReceivablesUpload, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FdProjectReceivablesUpload> pageList = fdProjectReceivablesUploadService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "项目因收款附件表列表");
      mv.addObject(NormalExcelConstants.CLASS, FdProjectReceivablesUpload.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("项目因收款附件表列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FdProjectReceivablesUpload> listFdProjectReceivablesUploads = ExcelImportUtil.importExcel(file.getInputStream(), FdProjectReceivablesUpload.class, params);
              for (FdProjectReceivablesUpload fdProjectReceivablesUploadExcel : listFdProjectReceivablesUploads) {
                  fdProjectReceivablesUploadService.save(fdProjectReceivablesUploadExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFdProjectReceivablesUploads.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

  /***
   * @Title:附件批量新增
          * @Description:TODO
          * @param fdProjectReceivables
          * @return org.jeecg.common.api.vo.Result
          * @exception 
          * @author 陈创
          * @date 2019/9/9 17:30
          * @updatehistory:
   *   2019/9/9 17:30 新增
          */
	 @PostMapping(value = "/batchUpload")
	 public Result batchUpload(@RequestBody FdProjectReceivables fdProjectReceivables) {
		 Result result = new Result();
		 try {
			 //批量删除
			 LambdaQueryWrapper<FdProjectReceivablesUpload> fdProjectReceivablesUploadLambdaQueryWrapper=new LambdaQueryWrapper<>();
			 fdProjectReceivablesUploadLambdaQueryWrapper.eq(FdProjectReceivablesUpload::getProjectId,fdProjectReceivables.getId());
			 fdProjectReceivablesUploadService.remove(fdProjectReceivablesUploadLambdaQueryWrapper);

			 //批量保存
			 fdProjectReceivablesUploadService.saveBatch(fdProjectReceivables.getFdProjectReceivablesUploadList());
			 result.setSuccess(true);
		 } catch (Exception e) {
			 e.printStackTrace();
			 result.error500("操作失败" + e.getMessage());
		 }
		 return result;
	 }

}
